"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

const executeMiddlewares = (middlewares, webSocket, resolve) => {
  if (middlewares.length === 0) {
    const {
      upgradeReq
    } = webSocket;
    resolve({
      req: upgradeReq
    });
  } else {
    const nextMiddleware = middlewares[0];
    const remainingMiddlewares = middlewares.slice(1);
    const response = {};
    nextMiddleware(webSocket.upgradeReq, response, () => executeMiddlewares(remainingMiddlewares, webSocket, resolve));
  }
};

const createSubscriptionOnConnect = middlewares => {
  // This is called on each message that has a GQL_CONNECTION_INIT message type
  const onConnect = (connectionParams, webSocket) => new Promise(resolve => executeMiddlewares(middlewares, webSocket, resolve));

  return onConnect;
};

var _default = createSubscriptionOnConnect;
exports.default = _default;
//# sourceMappingURL=createSubscriptionOnConnect.js.map